diff a/test/hotspot/jtreg/premain/jmh/run.sh b/test/hotspot/jtreg/premain/jmh/run.sh
--- /dev/null
+++ b/test/hotspot/jtreg/premain/jmh/run.sh
@@ -0,0 +1,100 @@
+# Copyright (c) 2023, Oracle and/or its affiliates. All rights reserved.
+# DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR THIS FILE HEADER.
+#
+# This code is free software; you can redistribute it and/or modify it
+# under the terms of the GNU General Public License version 2 only, as
+# published by the Free Software Foundation.
+#
+# This code is distributed in the hope that it will be useful, but WITHOUT
+# ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
+# FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
+# version 2 for more details (a copy is included in the LICENSE file that
+# accompanied this code).
+#
+# You should have received a copy of the GNU General Public License version
+# 2 along with this work; if not, write to the Free Software Foundation,
+# Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA.
+#
+# Please contact Oracle, 500 Oracle Parkway, Redwood Shores, CA 94065 USA
+# or visit www.oracle.com if you need additional information or have any
+# questions.
+
+# run JMH with premain prototype
+#
+# run all tests
+#      bash run.sh $JAVA
+# run a single test
+#      bash run.sh $JAVA 2
+# clean up
+#      make clean
+
+JAVA=$1; shift 
+JAR=specjbb2005-jmh-1.25.jar
+CMDLINE="-jar $JAR Jbb -t 1 -f 0 -r 1 -i 2 -wi 0"
+APP=specjbb2005-jmh
+
+ONLYTEST=$1
+
+TEST_NUM=0
+
+function do_test () {
+    TEST_NUM=$(expr $TEST_NUM + 1)
+
+    echo ========================================
+    echo Test $TEST_NUM $1
+
+    shift
+    if test "$ONLYTEST" != "" -a "$ONLYTEST" != "$TEST_NUM"; then
+        echo "$@"
+        echo "SKIPPED"
+        return 0
+    else
+        local before_errfiles=$(ls hs_err*  2> /dev/null | sort)
+        echo "$@"
+        if eval "$@"; then
+            true
+        else
+            echo "FAILED; command line was:"
+            echo "$@";
+            exit 1
+        fi
+        local after_errfiles=$(ls hs_err*  2> /dev/null | sort)
+        if test "$before_errfiles" != "$after_errfiles"; then
+            echo "HotSpot crashed (check hs_err errfiles); command line was:"
+            echo "$@"
+            exit 1
+        fi
+        echo "PASSED $TEST_NUM"
+        if test "$ONLYTEST" = "$TEST_NUM"; then
+            echo "Exiting after test $TEST_NUM has passed. Further tests may have been skipped"
+            exit 0
+        fi
+    fi
+}
+
+do_test "(STEP 1 of 5) Dump classlist" \
+        $JAVA -Xshare:off -XX:DumpLoadedClassList=$APP.classlist $CMDLINE
+
+do_test "(STEP 2 of 5) Create Static $APP-static.jsa" \
+    $JAVA -Xshare:dump -XX:SharedArchiveFile=$APP-static.jsa -XX:SharedClassListFile=$APP.classlist -cp $JAR \
+    -Xlog:cds=debug,cds+class=debug,cds+resolve=debug:file=$APP-static.dump.log
+
+if false; then
+    do_test "Run with $APP-static.jsa" \
+            $JAVA -XX:SharedArchiveFile=$APP-static.jsa $CMDLINE
+fi
+
+do_test "(STEP 3 of 5) Run with $APP-static.jsa and dump profile in $APP-dynamic.jsa (With Training Data Replay)" \
+    $JAVA -XX:SharedArchiveFile=$APP-static.jsa -XX:ArchiveClassesAtExit=$APP-dynamic.jsa -XX:+RecordTraining \
+        -Xlog:cds=debug,cds+class=debug:file=$APP-dynamic.dump.log \
+        $CMDLINE
+
+do_test "(STEP 4 of 5) Run with $APP-dynamic.jsa and generate AOT code" \
+    $JAVA -XX:SharedArchiveFile=$APP-dynamic.jsa -XX:+ReplayTraining -XX:+StoreCachedCode \
+        -Xlog:scc*=warning:file=$APP-store-sc.log \
+        -XX:CachedCodeFile=$APP-dynamic.jsa-sc -XX:CachedCodeMaxSize=100M $CMDLINE
+
+do_test "(STEP 5 of 5) Final production run: with $APP-dynamic.jsa and load AOT code" \
+    $JAVA -XX:SharedArchiveFile=$APP-dynamic.jsa -XX:+ReplayTraining -XX:+LoadCachedCode \
+        -Xlog:scc*=warning:file=$APP-load-sc.log \
+        -XX:CachedCodeFile=$APP-dynamic.jsa-sc $CMDLINE
diff a/test/hotspot/jtreg/premain/lib/Bench.gmk b/test/hotspot/jtreg/premain/lib/Bench.gmk
--- /dev/null
+++ b/test/hotspot/jtreg/premain/lib/Bench.gmk
@@ -0,0 +1,87 @@
+# Copyright (c) 2024, Oracle and/or its affiliates. All rights reserved.
+# DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR THIS FILE HEADER.
+#
+# This code is free software; you can redistribute it and/or modify it
+# under the terms of the GNU General Public License version 2 only, as
+# published by the Free Software Foundation.
+#
+# This code is distributed in the hope that it will be useful, but WITHOUT
+# ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
+# FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
+# version 2 for more details (a copy is included in the LICENSE file that
+# accompanied this code).
+#
+# You should have received a copy of the GNU General Public License version
+# 2 along with this work; if not, write to the Free Software Foundation,
+# Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA.
+#
+# Please contact Oracle, 500 Oracle Parkway, Redwood Shores, CA 94065 USA
+# or visit www.oracle.com if you need additional information or have any
+# questions.
+
+
+# You can choose a different number of loops like this:
+#     make compare_premain_builds LOOPS="0 1 2" PM_OLD=.....
+
+LOOPS = 0 1 2 3 4 5 6 7 8 9 10
+SLEEP = sleep 1;
+
+bench: mainline_vs_premain
+
+mainline_vs_premain: clean0 _mainline_vs_premain
+
+_mainline_vs_premain:
+	rm -f mainline_vs_premain.csv
+	@echo "run,mainline default,mainline custom static CDS,premain custom static CDS only,premain CDS + AOT" | tee -a mainline_vs_premain.csv
+	@first=1; for i in ${LOOPS}; do \
+		rm -f tmp.txt; \
+		$(SLEEP) $(MAKE) LOG_INIT= run0.ml 2>&1 | grep Booted >> tmp.txt; \
+		$(SLEEP) $(MAKE) LOG_INIT= runs.ml 2>&1 | grep Booted >> tmp.txt; \
+		$(SLEEP) $(MAKE) LOG_INIT= runs    2>&1 | grep Booted >> tmp.txt; \
+		$(SLEEP) $(MAKE) LOG_INIT= runn    2>&1 | grep Booted >> tmp.txt; \
+		if test "$$first" != "1"; then \
+		    echo $$i$$(cat tmp.txt | sed -e 's/.*in /,/g' -e 's/ms//g') | sed -e 's/ //g' | tee -a mainline_vs_premain.csv; \
+	        fi; \
+		first=0; \
+	done
+	@${MAINLINE_JAVA} ../lib/GithubMDChart.java mainline_vs_premain.md < mainline_vs_premain.csv
+
+# Compare two premain builds running "make run"
+#
+# make PM_OLD=/repos/leyden_old/build/linux-x64/images/jdk \
+#      PM_NEW=/repos/leyden_new/build/linux-x64/images/jdk \
+#      BLDJDK_HOME=/usr/local/jdk21 \
+#      compare_premain_builds
+#
+# Note: you can also use the same build, but use different option to enable/disable certain features. E.g.
+#
+# make PM_OLD=/repo/leyden/build/linux-x64/images/jdk PM_OPTS_NEW=-XX:-ArchivePackages \
+#      PM_NEW=/repo/leyden/build/linux-x64/images/jdk PM_OPTS_NEW=-XX:+ArchivePackages \
+#      BLDJDK_HOME=/my/jdk/21/home
+#      compare_premain_builds
+#
+# Or .. to benchmark a feature that you're developing
+#
+# make PM_OLD=/repos/leyden/build/linux-x64/images/jdk PM_OPTS_OLD="-XX:+UnlockDiagnosticVMOptions -XX:-UseNewCode" \
+#      PM_NEW=/repos/leyden/build/linux-x64/images/jdk PM_OPTS_NEW="-XX:+UnlockDiagnosticVMOptions -XX:+UseNewCode" \
+#      BLDJDK_HOME=/usr/local/jdk21 \
+#      compare_premain_builds
+#
+
+compare_premain_builds: clean0 _compare_premain_builds
+
+_compare_premain_builds:
+	@rm -f compare_premain_builds.csv
+	@echo Old build = ${PM_OLD} with options ${PM_OPTS_OLD}
+	@echo New build = ${PM_NEW} with options ${PM_OPTS_NEW}
+	@echo "Run,Old CDS + AOT,New CDS + AOT" | tee -a compare_premain_builds.csv
+	@first=1; for i in ${LOOPS}; do \
+		rm -f tmp.txt; \
+		$(SLEEP) $(MAKE) LOG_INIT= PREMAIN_HOME=${PM_OLD} PM_VER=.old PM_OPTS="${PM_OPTS_OLD}" runn 2>&1 | grep Booted >> tmp.txt; \
+		$(SLEEP) $(MAKE) LOG_INIT= PREMAIN_HOME=${PM_NEW} PM_VER=.new PM_OPTS="${PM_OPTS_NEW}" runn 2>&1 | grep Booted >> tmp.txt; \
+		if test "$$first" != "1"; then \
+		    echo $$i$$(cat tmp.txt | sed -e 's/.*in /,/g' -e 's/ms//g') | sed -e 's/ //g' | tee -a compare_premain_builds.csv; \
+	        fi; \
+		first=0; \
+	done
+	@${MAINLINE_JAVA} ../lib/GithubMDChart.java compare_premain_builds.md < compare_premain_builds.csv
diff a/test/hotspot/jtreg/premain/lib/DemoSupport.gmk b/test/hotspot/jtreg/premain/lib/DemoSupport.gmk
--- /dev/null
+++ b/test/hotspot/jtreg/premain/lib/DemoSupport.gmk
@@ -0,0 +1,179 @@
+# Copyright (c) 2024, Oracle and/or its affiliates. All rights reserved.
+# DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR THIS FILE HEADER.
+#
+# This code is free software; you can redistribute it and/or modify it
+# under the terms of the GNU General Public License version 2 only, as
+# published by the Free Software Foundation.
+#
+# This code is distributed in the hope that it will be useful, but WITHOUT
+# ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
+# FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
+# version 2 for more details (a copy is included in the LICENSE file that
+# accompanied this code).
+#
+# You should have received a copy of the GNU General Public License version
+# 2 along with this work; if not, write to the Free Software Foundation,
+# Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA.
+#
+# Please contact Oracle, 500 Oracle Parkway, Redwood Shores, CA 94065 USA
+# or visit www.oracle.com if you need additional information or have any
+# questions.
+
+#===============================================================================
+# HOWTO
+#===============================================================================
+
+# Build the app from source code
+#    make app
+#
+# Run with all Leyden optimizations (new workflow)
+#    make run
+#    make runn
+#
+# Run with all CDS static archive only (with Leyden repo)
+#    make runs
+#
+# Run without Leyden optimizations (with Leyden repo)
+#    make run0
+#
+
+#===============================================================================
+# Environment Config
+#===============================================================================
+
+# The best way to set the paths to various JDKs is to use environment variables to
+# set the values for the following variables. E.g.
+#  export BLDJDK_HOME=/home/$USER/jdk21
+#  export MAINLINE_HOME=/home/$USER/repo/jdk/build/linux-x64/images/jdk
+#  export PREMAIN_HOME=/home/$USER/leyden/jdk/build/linux-x64/images/jdk
+#  make run
+
+#  *** NOTE: JDK 21 is needed to build most of the demos
+ifndef BLDJDK_HOME
+BLDJDK_HOME   = /jdk3/official/jdk21
+endif
+
+# Points to your build with https://github.com/openjdk/jdk
+# For comparison purposes, this build should be the latest version of the mainline that
+# has been merged into https://github.com/openjdk/leyden/tree/premain
+ifndef MAINLINE_HOME
+MAINLINE_HOME = /jdk3/bld/rum/images/jdk
+endif
+
+# Points to your build with https://github.com/openjdk/leyden/tree/premain
+ifndef PREMAIN_HOME
+PREMAIN_HOME = /jdk3/bld/le4/images/jdk
+endif
+
+# Override this if your system's MVM version is too old (to point to your own build of mvn, etc)
+ifndef MVN
+MVN = mvn
+endif
+
+#===============================================================================
+# Common Makefile rules for Leyden demos
+#===============================================================================
+
+# Options passed to PREMAIN_JAVA. See compare_premain_builds in ./Bench.gmk
+PM_OPTS =
+
+JAR             = ${BLDJDK_HOME}/bin/jar
+BLDJDK_JAVA     = ${BLDJDK_HOME}/bin/java
+MAINLINE_JAVA   = ${MAINLINE_HOME}/bin/java
+PREMAIN_JAVA    = ${PREMAIN_HOME}/bin/java ${PM_OPTS}
+
+# The following variables should be defined by the main Makefile.
+# See ../helidon-quickstart-se/Makefile for an example.
+
+DEMO_CLASSLIST  = ${DEMO_NAME}$(PM_VER).classlist
+DEMO_JSA        = ${DEMO_NAME}$(PM_VER).jsa
+DEMO_CDS        = ${DEMO_NAME}$(PM_VER).cds
+
+DEMO_ML_CLASSLIST = ${DEMO_NAME}$(PM_VER).ml.classlist
+DEMO_ML_JSA       = ${DEMO_NAME}$(PM_VER).ml.jsa
+
+# Rules for the following targets should be specified in the main Makefile.
+# See ../helidon-quickstart-se/Makefile for an example.
+
+src: ${DEMO_SRC}
+app: ${DEMO_JAR}
+artifact: ${DEMO_ARTIFACT}
+
+#
+# The following rules should be common to all demos
+#
+
+# Run with the build JDK------------------------
+runb: ${DEMO_JAR}
+	${BLDJDK_JAVA} ${DEMO_CMDLINE}
+
+# No optimizations (Leyden repo)----------------
+run0: ${DEMO_JAR}
+	${PREMAIN_JAVA} ${DEMO_CMDLINE}
+
+# Static CDS only (Leyden repo)-----------------
+
+list:  ${DEMO_CLASSLIST}
+jsa:   ${DEMO_JSA}
+
+${DEMO_CLASSLIST}: ${DEMO_JAR}
+	${PREMAIN_JAVA} -Xshare:off -XX:DumpLoadedClassList=${DEMO_CLASSLIST} ${DEMO_CMDLINE}
+
+${DEMO_JSA}: ${DEMO_CLASSLIST}
+	rm -f ${DEMO_JSA}.log
+	${PREMAIN_JAVA} -Xshare:dump -XX:SharedClassListFile=${DEMO_CLASSLIST} -XX:SharedArchiveFile=${DEMO_JSA} \
+	    -XX:+AOTClassLinking \
+	    -Xlog:cds=debug,cds+class=debug,cds+heap=warning,cds+resolve=debug:file=${DEMO_JSA}.log \
+	    ${DEMO_CMDLINE}
+
+runs:  ${DEMO_JSA}
+	${PREMAIN_JAVA} -XX:SharedArchiveFile=${DEMO_JSA} ${DEMO_CMDLINE}
+
+# Static CDS only (Leyden repo)-----------------
+
+list.ml:  ${DEMO_ML_CLASSLIST}
+jsa.ml:   ${DEMO_ML_JSA}
+
+${DEMO_ML_CLASSLIST}: ${DEMO_JAR}
+	${MAINLINE_JAVA} -Xshare:off -XX:DumpLoadedClassList=${DEMO_ML_CLASSLIST} ${DEMO_CMDLINE}
+
+${DEMO_ML_JSA}: ${DEMO_ML_CLASSLIST}
+	rm -f ${DEMO_ML_JSA}.log
+	${MAINLINE_JAVA} -Xshare:dump -XX:SharedClassListFile=${DEMO_ML_CLASSLIST} -XX:SharedArchiveFile=${DEMO_ML_JSA} \
+	    -Xlog:cds=debug,cds+class=debug,cds+heap=warning,cds+resolve=debug:file=${DEMO_ML_JSA}.log \
+	    ${DEMO_CMDLINE}
+
+run0.ml: ${DEMO_JAR}
+	${MAINLINE_JAVA} ${DEMO_CMDLINE}
+
+runs.ml: ${DEMO_ML_JSA}
+	${MAINLINE_JAVA} -XX:SharedArchiveFile=${DEMO_ML_JSA} ${DEMO_CMDLINE}
+
+# Leyden new workflow --------------------------
+
+cds: ${DEMO_CDS}
+
+${DEMO_CDS}: ${DEMO_JAR}
+	rm -f ${DEMO_CDS} ${DEMO_CDS}.log
+	${PREMAIN_JAVA} \
+	    -XX:CacheDataStore=${DEMO_CDS} -XX:CachedCodeMaxSize=512M \
+	    -Xlog:scc,cds=debug,cds+class=debug,cds+heap=warning,cds+resolve=debug:file=${DEMO_CDS}.log::filesize=0 \
+	     ${DEMO_CMDLINE}
+	ls -l ${DEMO_CDS}
+	ls -l ${DEMO_CDS}.code
+
+run: runn
+
+runn: ${DEMO_CDS}
+	${PREMAIN_JAVA} \
+	    -XX:CacheDataStore=${DEMO_CDS} \
+	    -Xlog:scc*=error \
+	     ${DEMO_CMDLINE}
+
+showenv:
+	@echo "BLDJDK_JAVA   = ${BLDJDK_JAVA}"
+	@echo "MAINLINE_JAVA = ${MAINLINE_JAVA}"
+	@echo "PREMAIN_JAVA  = ${PREMAIN_JAVA}"
+
+
+include ../lib/Bench.gmk
diff a/test/hotspot/jtreg/premain/lib/GithubMDChart.java b/test/hotspot/jtreg/premain/lib/GithubMDChart.java
--- /dev/null
+++ b/test/hotspot/jtreg/premain/lib/GithubMDChart.java
@@ -0,0 +1,190 @@
+/*
+ * Copyright (c) 2024, Oracle and/or its affiliates. All rights reserved.
+ * DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR THIS FILE HEADER.
+ *
+ * This code is free software; you can redistribute it and/or modify it
+ * under the terms of the GNU General Public License version 2 only, as
+ * published by the Free Software Foundation.
+ *
+ * This code is distributed in the hope that it will be useful, but WITHOUT
+ * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
+ * FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
+ * version 2 for more details (a copy is included in the LICENSE file that
+ * accompanied this code).
+ *
+ * You should have received a copy of the GNU General Public License version
+ * 2 along with this work; if not, write to the Free Software Foundation,
+ * Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA.
+ *
+ * Please contact Oracle, 500 Oracle Parkway, Redwood Shores, CA 94065 USA
+ * or visit www.oracle.com if you need additional information or have any
+ * questions.
+ */
+
+/*
+ Used by DemoSupport.gmk:
+ 
+ - calculate the geomean and stdev of benchmark runs
+ - write markdown snippets for rendering benchmark results as a chart on GitHub .MD files
+
+Example:
+
+helidon-quickstart-se$ tbjava ../lib/GithubMDChart.java < mainline_vs_premain.csv
+run,mainline default,mainline custom static CDS,premain custom static CDS only,premain CDS + AOT
+1,398,244,144,107
+2,387,247,142,108
+3,428,238,143,107
+4,391,252,142,111
+5,417,247,141,107
+6,390,239,139,127
+7,387,247,145,111
+8,387,240,147,110
+9,388,242,147,108
+10,400,242,167,108
+Geomean,397.08,243.76,145.52,110.26
+Stdev,13.55,4.19,7.50,5.73
+
+```mermaid
+---
+config:
+    xyChart:
+        chartOrientation: horizontal
+        height: 300
+---
+xychart-beta
+    x-axis "variant" ["mainline default", "mainline custom static CDS", "premain custom static CDS only", "premain CDS + AOT"]
+    y-axis "Elapsed time (ms, smaller is better)" 0 --> 397
+    bar [397, 244, 146, 110]
+```
+
+*/
+
+import java.io.PrintWriter;
+import java.util.Scanner;
+import java.util.ArrayList;
+import java.util.Arrays;
+
+public class GithubMDChart {
+    @SuppressWarnings("unchecked")
+    public static void main(String args[]) throws Exception {
+        Scanner input = new Scanner(System.in);
+        String line = input.nextLine();
+        //System.out.println(line);
+        String head[] = line.split(",");
+        Object[] groups = new Object[head.length];
+        String[] geomeans = new String[head.length];
+        for (int i = 0; i < head.length; i++) {
+            groups[i] = new ArrayList<Double>();
+        }
+        while (input.hasNext()) {
+            line = input.nextLine();
+            //System.out.println(line);
+            String parts[] = line.split(",");
+            for (int i = 0; i < head.length; i++) {
+                ArrayList<Double> list =  (ArrayList<Double>)(groups[i]);
+                list.add(Double.valueOf(Double.parseDouble(parts[i])));
+            }
+        }
+
+        for (int i = 0; i < head.length; i++) {
+            ArrayList<Double> list =  (ArrayList<Double>)(groups[i]);
+            if (i == 0) {
+                System.out.print("Geomean");
+            } else {
+                System.out.print(",");
+                geomeans[i] = geomean(list);
+                System.out.print(geomeans[i]);
+            }
+        }
+
+        System.out.println();
+
+        for (int i = 0; i < head.length; i++) {
+            ArrayList<Double> list =  (ArrayList<Double>)(groups[i]);
+            if (i == 0) {
+                System.out.print("Stdev");
+            } else {
+                System.out.print(",");
+                System.out.print(stdev(list));
+            }
+        }
+        System.out.println();
+        System.out.println("Markdown snippets in " + args[0]);
+
+        String[] norm = new String[geomeans.length];
+        for (int i = 1; i < head.length; i++) {
+            double base = Double.parseDouble(geomeans[1]);
+            double me   = Double.parseDouble(geomeans[i]);
+            norm[i] = String.format("%.0f", 1000.0 * me / base);
+        }
+
+        PrintWriter pw = new PrintWriter(args[0]);
+        // Horizontal avoids issues with long names overlapping each other,
+        // and setting a smaller-than-default height makes it easier to overlook and compare.
+        pw.println("""
+        ```mermaid
+        ---
+        config:
+            xyChart:
+                chartOrientation: horizontal
+                height: 300
+        ---
+        xychart-beta
+            x-axis "variant" [$names]
+            y-axis "Elapsed time (ms, smaller is better)" 0 --> $maxtime
+            bar [$geomeans]
+        ```
+        
+        -----------------Normalized---------------------------------------------
+        ```mermaid
+        ---
+        config:
+            xyChart:
+                chartOrientation: horizontal
+                height: 300
+        ---
+        xychart-beta
+            x-axis "variant" [$names]
+            y-axis "Elapsed time (normalized, smaller is better)" 0 --> 1000
+            bar [$norms]
+        ```
+        """
+        .replace("$names", '"' + String.join("\", \"", Arrays.copyOfRange(head, 1, head.length)) + '"')
+        .replace("$maxtime", geomeans[1])
+        .replace("$geomeans", String.join(", ", Arrays.copyOfRange(geomeans, 1, geomeans.length)))
+        .replace("$norms", String.join(", ", Arrays.copyOfRange(norm, 1, norm.length)))
+        );
+        pw.close();
+    }
+
+
+    static String geomean(ArrayList<Double> list) {
+        double log = 0.0d;
+        for (Double d : list) {
+            double v = d.doubleValue();
+            if (v <= 0) {
+                v = 0.000001;
+            }
+            log += Math.log(v);
+        }
+
+	return String.format("%.2f", Math.exp(log / list.size()));
+    }
+
+    static String stdev(ArrayList<Double> list) {
+        double sum = 0.0;
+        for (Double d : list) {
+            sum += d.doubleValue();
+        }
+
+        double length = list.size();
+        double mean = sum / length;
+
+        double stdev = 0.0;
+        for (Double d : list) {
+            stdev += Math.pow(d.doubleValue() - mean, 2);
+        }
+
+	return String.format("%.2f", Math.sqrt(stdev / length));
+    }
+}
